123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353 |
- #!/bin/bash
- #
- # snf-server Starts and stops the SNFServer daemon (SUSE).
- #
- # Author-- Alban Deniz
- #
- # Copyright (C) 2008 ARM Research Labs, LLC.
- # See www.armresearch.com for the copyright terms.
- #
- # chkconfig: 345 80 30
- # description: SNFServer providing email filtering.
- #
- ### BEGIN INIT INFO
- # Provides: SNFServer
- # Required-Start: $syslog $remote_fs $network $named
- # Should-Start: $time ypbind smtp
- # Required-Stop: $syslog $remote_fs
- # Should-Stop: $time ypbind smtp
- # Default-Start: 3 5
- # Default-Stop: 0 1 2 6
- # Short-Description: SNFServer providing email filtering.
- # Description: Start SNFServer to filter email for spam and
- # check IP addresses.
- ### END INIT INFO
-
- # Directory to run in.
- runDir=PREFIX/share/PACKAGE_NAME
-
- # Define mode files.
- debugModeFile=$runDir/debug_mode
- productionModeFile=$runDir/production_mode
-
- # Set debug mode flag.
- if [ -f $debugModeFile ]
- then
- debugMode=true
- fi
-
- # Debug output file.
- debugOutputFile=/var/log/PACKAGE_NAME/debug.log
-
- # Location of installation.
- installedDir="PREFIX"
-
- # Location of programs.
- dir="$installedDir/sbin"
-
- # Name of config file.
- configFile="CONFFILE"
-
- # Name of daemon.
- debugProg="SNFDebugServer"
- productionProg="SNFServer"
-
- # Name of client.
- clientProg="SNFClient"
-
- # Name of user to run as.
- userName="snfuser"
-
- # Name of lockfile.
- lockFile="/var/lock/subsys/$productionProg"
-
- # Name of client.
- clientProg="SNFClient"
-
- # Check for missing binaries (stale symlinks should not happen)
- # Note: Special treatment of stop for LSB conformance
- SNFServer_BIN=$dir/$productionProg
- test -x $SNFServer_BIN || { echo $"$SNFServer_BIN not installed";
- if [ "$1" = "stop" ]; then exit 0;
- else exit 5; fi; }
-
- # Use the SUSE rc_ init script functions;
- # emulate them on LSB, RH and other systems
-
- # Default: Assume sysvinit binaries exist
- start_daemon() { /sbin/start_daemon ${1+"$@"}; }
- killproc() { /sbin/killproc ${1+"$@"}; }
- pidofproc() { /sbin/pidofproc ${1+"$@"}; }
- checkproc() { /sbin/checkproc ${1+"$@"}; }
- if test -e /etc/rc.status; then
- # SUSE rc script library
- . /etc/rc.status
- else
- export LC_ALL=POSIX
- _cmd=$1
- declare -a _SMSG
- if test "${_cmd}" = "status"; then
- _SMSG=(running dead dead unused unknown reserved)
- _RC_UNUSED=3
- else
- _SMSG=(done failed failed missed failed skipped unused failed failed reserved)
- _RC_UNUSED=6
- fi
- if test -e /lib/lsb/init-functions; then
- # LSB
- . /lib/lsb/init-functions
- echo_rc()
- {
- if test ${_RC_RV} = 0; then
- log_success_msg " [${_SMSG[${_RC_RV}]}] "
- else
- log_failure_msg " [${_SMSG[${_RC_RV}]}] "
- fi
- }
- # TODO: Add checking for lockfiles
- checkproc() { return pidofproc ${1+"$@"} >/dev/null 2>&1; }
- elif test -e /etc/init.d/functions; then
- # RHAT
- . /etc/init.d/functions
- echo_rc()
- {
- #echo -n " [${_SMSG[${_RC_RV}]}] "
- if test ${_RC_RV} = 0; then
- success " [${_SMSG[${_RC_RV}]}] "
- else
- failure " [${_SMSG[${_RC_RV}]}] "
- fi
- }
- checkproc() { return status ${1+"$@"}; }
- start_daemon() { return daemon ${1+"$@"}; }
- else
- # emulate it
- echo_rc() { echo $" [${_SMSG[${_RC_RV}]}] "; }
- fi
- rc_reset() { _RC_RV=0; }
- rc_failed()
- {
- if test -z "$1"; then
- _RC_RV=1;
- elif test "$1" != "0"; then
- _RC_RV=$1;
- fi
- return ${_RC_RV}
- }
- rc_check()
- {
- return rc_failed $?
- }
- rc_status()
- {
- rc_failed $?
- if test "$1" = "-r"; then _RC_RV=0; shift; fi
- if test "$1" = "-s"; then rc_failed 5; echo_rc; rc_failed 3; shift; fi
- if test "$1" = "-u"; then rc_failed ${_RC_UNUSED}; echo_rc; rc_failed 3; shift; fi
- if test "$1" = "-v"; then echo_rc; shift; fi
- if test "$1" = "-r"; then _RC_RV=0; shift; fi
- return ${_RC_RV}
- }
- rc_exit() { exit ${_RC_RV}; }
- rc_active()
- {
- if test -z "$RUNLEVEL"; then read RUNLEVEL REST < <(/sbin/runlevel); fi
- if test -e /etc/init.d/S[0-9][0-9]${1}; then return 0; fi
- return 1
- }
- fi
-
- # Reset status of this service
- rc_reset
-
- #
- # Function to create the mode file.
- #
- createModeFile()
- {
- fileName=$1
-
- # Remove any existing mode files.
- rm -f $productionModeFile $debugModeFile $fileName
- (
- echo $"PACKAGE_NAME mode file"
- echo
- echo $"This file specifies whether PACKAGE_NAME is configured to run in"
- echo $"production mode or debug mode. If the name of this file is"
- echo $"'production_mode', then PACKAGE_NAME is configured to run in"
- echo $"production mode. If the name is 'debug_mode', then PACKAGE_NAME is"
- echo $"configured to run in debug mode."
- echo
- echo $"To run in debug mode:"
- echo
- echo $" 1) Run 'PACKAGE_NAME debug_mode'"
- echo
- echo $" 2) Run 'PACKAGE_NAME restart' (if PACKAGE_NAME is already running),"
- echo $" or 'PACKAGE_NAME start' (to start PACKAGE_NAME)"
- echo
- echo $"To run in production mode:"
- echo
- echo $" 1) Run 'PACKAGE_NAME production_mode'"
- echo
- echo $" 2) Run 'PACKAGE_NAME restart' (if PACKAGE_NAME is already running),"
- echo $" or 'PACKAGE_NAME start' (to start PACKAGE_NAME)"
- echo
- echo $"By default, PACKAGE_NAME is configured to run in production mode."
- ) > $fileName
-
- }
-
- # Return values acc. to LSB for all commands but status:
- # 0 - success
- # 1 - generic or unspecified error
- # 2 - invalid or excess argument(s)
- # 3 - unimplemented feature (e.g. "reload")
- # 4 - user had insufficient privileges
- # 5 - program is not installed
- # 6 - program is not configured
- # 7 - program is not running
- # 8--199 - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
- #
- # Note that starting an already running service, stopping
- # or restarting a not-running service as well as the restart
- # with force-reload (in case signaling is not supported) are
- # considered a success.
-
- start(){
- echo -n $"Starting $productionProg: "
- for prog in $productionProg $debugProg
- do
- SNFPID=$(pidof -s $dir/$prog)
- if [ -n "$SNFPID" ] ; then
- return 0
- fi
- done
-
- # Start.
- if [ $debugMode ]
- then
-
- # Enable core dumps and start with output redirected.
- (ulimit -c unlimited; \
- su $userName -s /bin/sh -c \
- "echo Starting $dir/$debugProg on $(date) >> $debugOutputFile"; \
- cd PREFIX/share/PACKAGE_NAME; \
- su $userName -c \
- "strace -r -tt -v $dir/$debugProg $configFile >> $debugOutputFile 2>&1 &" \
- -s /bin/sh)
-
- else
-
- (cd PREFIX/share/PACKAGE_NAME; \
- su $userName -c "$dir/$productionProg $configFile > /dev/null 2>&1 &" \
- -s /bin/sh > /dev/null 2>&1)
- fi
-
-
- RETVAL=$?
- if [ $RETVAL -eq 0 ]; then
- $dir/$clientProg -status.second > /dev/null 2>&1
- RETVAL=$?
- fi
-
- if [ $RETVAL -eq 0 ]; then
- touch $lockFile
- else
- rc_failed 1
- fi
- return $RETVAL
- }
-
- stop(){
- echo -n $"Stopping $productionProg: "
- DEBUG_SNFPID=$(pidof -s $dir/$debugProg)
- PRODUCTION_SNFPID=$(pidof -s $dir/$productionProg)
- if [ -n "$DEBUG_SNFPID" ] || [ -n "$PRODUCTION_SNFPID" ]; then
- $dir/$clientProg -shutdown > /dev/null 2>&1
- sleep 10
-
- # Check that the programs are no longer running.
- RETVAL=0
- for prog in $debugProg $productionProg
- do
-
- SNFPID=$(pidof -s $dir/$prog)
- if [ -n "$SNFPID" ]; then
- kill $SNFPID
- RETVAL=$(($RETVAL+$?))
- fi
- done
- else
- # Process is not running.
- RETVAL=0
- fi
-
- if [ $RETVAL -eq 0 ]; then
- rm -f $lockFile
- else
- rc_failed 1
- fi
- return $RETVAL
- }
-
- restart(){
- stop
- start
- }
-
- case "$1" in
- start)
- start
-
- # Remember status and be verbose
- rc_status -v
- ;;
- stop)
- stop
-
- # Remember status and be verbose
- rc_status -v
- ;;
- restart)
- ## Stop the service and regardless of whether it was
- ## running or not, start it again.
- $0 stop
- $0 start
-
- # Remember status and be quiet
- rc_status
- ;;
- status)
- echo -n "Checking for service SNFServer "
- checkproc $SNFServer_BIN
- rc_status -v
- echo -n "Checking for service SNFDebugServer "
- checkproc $dir/$debugProg
- rc_status -v
- ;;
- debug_mode)
- #
- # Remove any mode flags, and create the debug_mode file.
- #
- echo $"Switching to debug mode"
- createModeFile $debugModeFile
- ;;
- production_mode)
- #
- # Remove any mode flags, and create the production_mode file.
- #
- echo $"Switching to production mode"
- createModeFile $productionModeFile
- ;;
- try-restart|condrestart|force-reload|reload|probe)
- # Not supported.
- echo -n "$0 $1 "
- rc_failed 3
- rc_status -v
- ;;
- *)
- echo $"Usage: $0 {start|stop|status|restart|production_mode|debug_mode}"
- exit 1
- ;;
- esac
- rc_exit
|